unit Qrepedit;
{
  Quick Report Editor v2.1

  Copyright (c) 1997,2000 Demidov Andre (andre@lion.susu.ac.ru)

  It is FREEWARE component and must be FREEWARE after
     your modifications.
  If you modify this component then
     send your modifications to autor, please.

}
interface
{$I QREPDEFS.INC}
uses
  Classes, Controls, Graphics,
{$IFDEF QR20}
  QuickRpt, QRCtrls, QRPrntr,
{$ELSE}
  QuickRep,
{$ENDIF}
  Menus, winTypes, extCtrls, db;

type
  string32 = string[32];
  TFormatValueType=(fvInteger,fvFloat,fvDateTime,fvString);
  TAutoResizeType=(arNoChange,arChangeSize,arChangePos);
{$IFDEF QR20}
  TAQRCell = class(TQRShape)
    private
      FAutoResize:TAutoResizeType;
      FTopCell:TAQRCell;
      FLeftCell:TAQRCell;
      FTopCellProcent:integer;
      FLeftCellProcent:integer;
      FUpdateSizes:boolean;
{$IFDEF WIN32}
      procedure SetTopCell(Cell:TAQRCell);
      procedure SetLeftCell(Cell:TAQRCell);
{$ELSE}
      procedure SetTopCell(Cell:TControl);
      procedure SetLeftCell(Cell:TControl);
      function GetTopCell:TControl;
      function GetLeftCell:TControl;
{$ENDIF}
      procedure SetTopCellProcent(pr:integer);
      procedure SetLeftCellProcent(pr:integer);
      procedure UpdateCell;
    protected
      property OnMouseDown;
      property OnMouseUp;
      property OnMouseMove;
      procedure Paint; override;
      procedure Print(OfsX,OfsY : Integer); override;
      procedure Notification(AComponent: TComponent; Operation: TOperation);
         override;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
      procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
      procedure SetNewSize(w,h:extended;flg:boolean);
      procedure SetNewPos(x,y:extended);
      procedure UntieLeft;
      procedure UntieTop;
      procedure TieLeft;
      procedure TieTop;
    public
      constructor Create(AOwner: TComponent); override;
      procedure UpdateSizes;
      procedure Tie;
      procedure UnTie;
    published
{$IFDEF WIN32}
      property TopCell:TAQRCell read FTopCell write SetTopCell;
      property LeftCell:TAQRCell read FLeftCell write SetLeftCell;
{$ELSE}
      property TopCell:TControl read GetTopCell write SetTopCell;
      property LeftCell:TControl read GetLeftCell write SetLeftCell;
{$ENDIF}
      property TopCellProcent:integer read FTopCellProcent write SetTopCellProcent default 100;
      property LeftCellProcent:integer read FLeftCellProcent write SetLeftCellProcent default 100;
      property AutoResize:TAutoResizeType read FAutoResize write FAutoResize default arNoChange;
  end;
{$ENDIF}

  TAQRLabel = class(TQRLabel)
    private
      FFieldName:string32;
      FFieldFormat:string32;
      FAutoResize:TAutoResizeType;
{$IFDEF QR20}
      FInCell:TAQRCell;
      FHShift:extended;
      FVShift:extended;
{$ENDIF}
      function FieldNameNotNull:boolean;
      function FieldFormatNotNull:boolean;
{$IFDEF QR20}
      procedure UpdateCell;
  {$IFDEF WIN32}
      procedure SetInCell(Cell:TAQRCell);
  {$ELSE}
      procedure SetInCell(Cell:TControl);
      function GetInCell:TControl;
  {$ENDIF}
      procedure SetHShift(a:extended);
      procedure SetVShift(a:extended);
{$ENDIF}
    protected
      property OnMouseDown;
      property OnMouseUp;
      property OnMouseMove;
{$IFDEF QR20}
      procedure Notification(AComponent: TComponent; Operation: TOperation);
         override;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
      procedure MouseMove(Shift: TShiftState; X, Y: integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
{$ENDIF}
    public
      constructor Create(AOwner: TComponent); override;
    published
{$IFDEF QR20}
  {$IFDEF WIN32}
      property InCell:TAQRCell read FInCell write SetInCell;
  {$ELSE}
      property InCell:TControl read GetInCell write SetInCell;
  {$ENDIF}
      property HShift:extended read FHShift write SetHShift;
      property VShift:extended read FVShift write SetVShift;
{$ENDIF}
      property FieldName:string32 read FFieldName write FFieldName stored FieldNameNotNull;
      property FieldFormat:string32 read FFieldFormat write FFieldFormat stored FieldFormatNotNull;
      property AutoResize:TAutoResizeType read FAutoResize write FAutoResize default arNoChange;
  end;

  TAQRShape = class(TQRShape)
    private
      FAutoResize:TAutoResizeType;
    protected
      property OnMouseDown;
      property OnMouseUp;
      property OnMouseMove;
{$IFDEF QR20}
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
      procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
{$ENDIF}
    public
      constructor Create(AOwner: TComponent); override;
    published
      property AutoResize:TAutoResizeType read FAutoResize write FAutoResize default arNoChange;
  end;

{$IFDEF QR20}
  TAQRImage = class(TQRImage)
    private
      FAutoResize:TAutoResizeType;
    protected
      property OnMouseDown;
      property OnMouseUp;
      property OnMouseMove;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
      procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    public
      constructor Create(AOwner: TComponent); override;
    published
      property AutoResize:TAutoResizeType read FAutoResize write FAutoResize default arNoChange;
  end;
{$ENDIF}


  TAQRMemo = class(TQRMemo)
    private
      FFieldName:string32;
      FFieldFormat:string32;
      FAutoResize:TAutoResizeType;
{$IFDEF QR20}
      FInCell:TAQRCell;
      FHShift:extended;
      FVShift:extended;
{$ENDIF}
      function FieldNameNotNull:boolean;
      function FieldFormatNotNull:boolean;
{$IFDEF QR20}
      procedure UpdateCell;
  {$IFDEF WIN32}
      procedure SetInCell(Cell:TAQRCell);
  {$ELSE}
      procedure SetInCell(Cell:TControl);
      function GetInCell:TControl;
  {$ENDIF}
      procedure SetHShift(a:extended);
      procedure SetVShift(a:extended);
{$ENDIF}
    protected
      property OnMouseDown;
      property OnMouseUp;
      property OnMouseMove;
{$IFDEF QR20}
      procedure Notification(AComponent: TComponent; Operation: TOperation);
         override;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
      procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
{$ENDIF}
    public
      constructor Create(AOwner: TComponent); override;
      function GetTextHeight:integer;
    published
{$IFDEF QR20}
  {$IFDEF WIN32}
      property InCell:TAQRCell read FInCell write SetInCell;
  {$ELSE}
      property InCell:TControl read GetInCell write SetInCell;
  {$ENDIF}
      property HShift:extended read FHShift write SetHShift;
      property VShift:extended read FVShift write SetVShift;
{$ENDIF}
      property FieldName:string32 read FFieldName write FFieldName stored FieldNameNotNull;
      property FieldFormat:string32 read FFieldFormat write FFieldFormat stored FieldFormatNotNull;
      property AutoResize:TAutoResizeType read FAutoResize write FAutoResize default arNoChange;
  end;

  TAQRBand = class(TQRBand)
    private
      function GetHeightAutoResize:integer;
      procedure SetHeightAutoResize(NewHeight:integer);
    protected
      property OnMouseDown;
      property OnMouseUp;
      property OnMouseMove;
{$IFDEF QR20}
    public
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
      procedure MouseMove(Shift: TShiftState; X, Y: integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
{$ENDIF}
    published
      property HeightAutoResize:integer read GetHeightAutoResize write SetHeightAutoResize default 0;
  end;

  TFormatValueEvent = procedure(Sender:TObject; const FormatStr:string;
       ValueType:TFormatValueType; ValuePtr:Pointer; var ResultStr:string) of object;
  TGetFieldNamesEvent = procedure(Sender:TObject; FieldNames:TStrings) of object;
  TGetFieldFormatsEvent = procedure(Sender:TObject; const FieldName:string;
       FieldFormats:TStrings) of object;

  TAQREditorFields = class;

  TAQREditor = class(TComponent)
  private
    MainMenu:TMainMenu;
    PopupMenu:TPopupMenu;
    MoveControl:TControl;
    FrameControl:TShape;
    PopupControl:TControl;
    MoveX,moveY:integer;
    MoveRect:Trect;
    MoveMode:integer;
    EditMode:integer;
    CreateClass:integer;
    FOnFormatValue:TFormatValueEvent;
    FOnGetFieldNames:TGetFieldNamesEvent;
    FOnGetFieldFormats:TGetFieldFormatsEvent;
    FOnPrintPreview:TNotifyEvent;
    FOnCreateMenu:TNotifyEvent;
    FFileName:string;
    FFieldDefs:TAQREditorFields;
    procedure EditControl(Sender: TControl);
    procedure EnableEdit;
    procedure DisableEdit;
    procedure GetFormats(Sender:TObject);
    procedure ControlMouseDown(Sender: TObject; Button: TMouseButton;
       Shift: TShiftState; X, Y: Integer);
    procedure ControlMouseMove(Sender: TObject; Shift: TShiftState;
        X, Y: Integer);
    procedure ControlMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
    procedure PopupMoveClick(Sender:TObject);
    procedure PopupChangeClick(Sender:TObject);
    procedure PopupDeleteClick(Sender:TObject);
    procedure PopupToBackClick(Sender:TObject);
    procedure PopupToFrontClick(Sender:TObject);
    procedure PopupTieClick(Sender:TObject);
    procedure PopupUntieClick(Sender:TObject);
    procedure FileOpenClick(Sender:TObject);
    procedure FileSaveClick(Sender:TObject);
    procedure FilePrinterClick(Sender:TObject);
    procedure FilePrintClick(Sender:TObject);
    procedure FilePageClick(Sender:TObject);
    procedure FileFieldsClick(Sender:TObject);
    procedure FileCloseClick(Sender:TObject);
    procedure EditCreateLabelClick(Sender:TObject);
    procedure EditCreateShapeClick(Sender:TObject);
    procedure EditCreateCellClick(Sender:TObject);
    procedure EditCreateMemoClick(Sender:TObject);
    procedure EditCreateImageClick(Sender: TObject);
    procedure EditCreateBandClick(Tip:TQRBandType);
    procedure EditCreateBand1Click(Sender:TObject);
    procedure EditCreateBand2Click(Sender:TObject);
    procedure EditCreateBand3Click(Sender:TObject);
    procedure EditCreateBand4Click(Sender:TObject);
    procedure EditCreateBand5Click(Sender:TObject);
    procedure EditPropertyClick(Sender:TObject);
    procedure EditMoveClick(Sender:TObject);
    procedure EditDeleteClick(Sender:TObject);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation);
         override;
    procedure DoFormatValue(const FormatStr:string;
       ValueType:TFormatValueType; ValuePtr:Pointer; var ResultStr:string);
         virtual;
  public
    procedure DefaultFormatValue(const FormatStr:string;
       ValueType:TFormatValueType; ValuePtr:Pointer; var ResultStr:String);
         virtual;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure EditReport;
    procedure LoadReport;
    procedure SetFieldValue(const FieldName:string; ValueType:TFormatValueType; ValuePtr:Pointer);
    procedure SetFieldInteger(const FieldName:string; Value:longint);
    procedure SetFieldFloat(const FieldName:string; Value:extended);
    procedure SetFieldString(const FieldName:string; const Value:string);
    procedure SetFieldDateTime(const FieldName:string; Value:TDateTime);
  published
    property FileName:string read FFileName write FFileName;
    property OnFormatValue:TFormatValueEvent read FOnFormatValue write FOnFormatValue;
    property OnGetFieldNames:TGetFieldNamesEvent read FOnGetFieldNames write FOnGetFieldNames;
    property OnGetFieldFormats:TGetFieldFormatsEvent read FOnGetFieldFormats write FOnGetFieldFormats;
    property OnPrintPreview:TNotifyEvent read FOnPrintPreview write FOnPrintPreview;
    property OnCreateMenu:TNotifyEvent read FOnCreateMenu write FOnCreateMenu;
  end;

  TAQREditorFields = class(TComponent)
  private
    FFieldNames:TStrings;
    FFieldFormats:TStrings;
    procedure SetFieldNames(Value:TStrings);
    procedure SetFieldFormats(Value:TStrings);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property FieldNames:TStrings read FFieldNames write SetFieldNames;
    property FieldFormats:TStrings read FFieldFormats write SetFieldFormats;
  end;

implementation
uses editimag,editpage,editband,editlabl,editshap,editmemo, sysutils, dialogs,
   Forms, stdCtrls, winprocs, qedconst, editflds, editCell,
   printers;

var ReportSaving:boolean;

{$IFDEF QR20}
{ TAQRCell }

constructor TAQRCell.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAutoResize:=arNoChange;
  FLeftCell:=nil;
  FTopCell:=nil;
  FLeftCellProcent:=100;
  FTopCellProcent:=100;
  FUpdateSizes:=false;
  Frame.DrawTop:=True;
  Frame.DrawBottom:=True;
  Frame.DrawLeft:=True;
  Frame.DrawRight:=True;
  Pen.Style:=psClear;
  Pen.Width:=0;
end;

procedure TAQRCell.UntieLeft;
var i:integer;
    cel:TAQRCell;
begin
  LeftCell:=nil;
  for i:=0 to Owner.ComponentCount-1 do
    if Owner.Components[i] is TAQRCell then
    begin
      cel:=TAQRCell(Owner.Components[i]);
      if (cel.TopCell=Self)
         and ((cel.LeftCell=nil) or (cel.LeftCell.TopCell<>Self)) then
         begin
           cel.UntieLeft;
           break;
         end;
    end;
end;
procedure TAQRCell.UntieTop;
var i:integer;
    cel:TAQRCell;
begin
  TopCell:=nil;
  for i:=0 to Owner.ComponentCount-1 do
    if Owner.Components[i] is TAQRCell then
    begin
      cel:=TAQRCell(Owner.Components[i]);
      if (cel.LeftCell=Self)
         and ((cel.TopCell=nil) or (cel.TopCell.LeftCell<>Self)) then
         begin
           cel.UntieTop;
           break;
         end;
    end;
end;
procedure TAQRCell.TieLeft;
var i:integer;
  cel:TAQRCell;
  pr:TWinControl;
  pt:Tpoint;
begin
  pr:=Parent;
  pt.x:=Left;
  pt.y:=Top;
  cel:=LeftCell;
  if cel=nil then
  begin
    for i:=0 to pr.ControlCount-1 do
      if pr.Controls[i] is TAQRCell then
        if (TAQRCell(pr.Controls[i]).Top<=pt.y) and
           (TAQRCell(pr.Controls[i]).Top+TAQRCell(pr.Controls[i]).Height-5>=pt.y)
           and (abs(TAQRCell(pr.Controls[i]).Left+TAQRCell(pr.Controls[i]).width-pt.x)<=5) then
           begin
             cel:=TAQRCell(pr.Controls[i]);
             break;
           end;
  end;
  LeftCell:=cel;
  for i:=0 to Owner.ComponentCount-1 do
    if Owner.Components[i] is TAQRCell then
    begin
      cel:=TAQRCell(Owner.Components[i]);
      if (cel.TopCell=Self)
         and ((cel.LeftCell=nil) or (cel.LeftCell.TopCell<>Self)) then
         begin
           cel.TieLeft;
           break;
         end;
    end;
end;
procedure TAQRCell.TieTop;
var i:integer;
  cel:TAQRCell;
  pr:TWinControl;
  pt:Tpoint;
begin
  pr:=Parent;
  pt.x:=Left;
  pt.y:=Top;
  cel:=nil;
  if (LeftCell<>nil) and (LeftCell.TopCell<>nil) and
     (LeftCell.TopCellProcent<100) and
     (LeftCell.TopCell.Left+LeftCell.TopCell.Width-1>
      LeftCell.Left+LeftCell.Width) then
  begin
    cel:=LeftCell.TopCell;
    if TopCellProcent=100 then
      TopCellProcent:=100-LeftCell.TopCellProcent;
  end
  else if pt.y<=5 then
  begin
    for i:=0 to Owner.ComponentCount-1 do
      if Owner.Components[i] is TAQRCell then
        if (abs(TAQRCell(Owner.Components[i]).Parent.Top+
         TAQRCell(Owner.Components[i]).Top+TAQRCell(Owner.Components[i]).Height
           -pr.top-pt.y)<=5)
          and (abs(TAQRCell(Owner.Components[i]).Left-pt.x)<=5) then
        begin
          cel:=TAQRCell(Owner.Components[i]);
          break;
       end;
  end
  else
  begin
    for i:=0 to pr.ControlCount-1 do
      if pr.Controls[i] is TAQRCell then
        if (abs(TAQRCell(pr.Controls[i]).Top+TAQRCell(pr.Controls[i]).Height-pt.y)<=5)
          and (abs(TAQRCell(pr.Controls[i]).Left-pt.x)<=5) then
        begin
          cel:=TAQRCell(pr.Controls[i]);
          break;
        end;
  end;
  TopCell:=cel;
  for i:=0 to Owner.ComponentCount-1 do
    if Owner.Components[i] is TAQRCell then
    begin
      cel:=TAQRCell(Owner.Components[i]);
      if (cel.LeftCell=Self)
         and ((cel.TopCell=nil) or (cel.TopCell.LeftCell<>Self)) then
         begin
           cel.TieTop;
           break;
         end;
    end;
end;
procedure TAQRCell.Tie;
begin
  TieLeft;
  TieTop;
end;
procedure TAQRCell.UnTie;
begin
  UntieLeft;
  UntieTop;
end;

procedure TAQRCell.Paint;
begin
  inherited paint;
  with Canvas do
  begin
    Pen := Self.Pen;
    Pen.Width:=Frame.Width;
    Pen.Style:=Frame.Style;
    Pen.Color:=Frame.Color;
    Brush := Self.Brush;
    if Frame.DrawTop then
    begin
          MoveTo(0,0);
          LineTo(Width,0);
    end;
    if Frame.DrawBottom then
    begin
          MoveTo(0,Height-1);
          LineTo(Width,Height-1);
    end;
    if Frame.DrawLeft then
    begin
          MoveTo(0,0);
          LineTo(0,Height);
    end;
    if Frame.DrawRight then
    begin
          MoveTo(Width-1,0);
          LineTo(Width-1,Height);
    end
  end
end;

procedure TAQRCell.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (Operation=opRemove) and not ReportSaving then
  begin
    if AComponent=FTopCell then
      FTopCell:=nil;
    if AComponent=FLeftCell then
      FLeftCell:=nil;
  end;
end;

procedure TAQRCell.Print(OfsX,OfsY : Integer);
begin
  inherited Print(OfsX,OfsY);
  if ParentReport.FinalPass then
  begin
    QRPrinter.Canvas.Brush := Brush;
    QRPrinter.Canvas.Pen := Pen;
    QRPrinter.Canvas.Pen.Color := Frame.Color;
    QRPrinter.Canvas.Pen.Style := Frame.Style;
    QRPrinter.Canvas.Pen.Width := Frame.Width;
    with QRPrinter do
    begin
      with Canvas do
      begin
        if Frame.DrawTop then
        begin
              MoveTo(XPos(OfsX + Size.Left), YPos(OfsY + Size.Top));
              LineTo(Xpos(OfsX + Size.Left + Size.Width), YPos(OfsY + Size.Top));
        end;
        if Frame.DrawBottom then
        begin
              MoveTo(Xpos(OfsX + Size.Left), YPos(OfsY + Size.Top + Size.Height));
              LineTo(Xpos(OfsX + Size.Left + Size.Width), Ypos(OfsY + Size.Top + Size.Height));
        end;
        if Frame.DrawLeft then
        begin
              MoveTo(XPos(OfsX + Size.Left), YPos(OfsY + Size.Top));
              LineTo(Xpos(OfsX + Size.Left), YPos(OfsY + Size.Top + Size.Height));
        end;
        if Frame.DrawRight then
        begin
              MoveTo(XPos(OfsX + Size.Left + Size.Width), YPos(OfsY + Size.Top));
              LineTo(XPos(OfsX + Size.Left + Size.Width), YPos(OfsY + Size.Top + Size.Height));
        end;
      end
    end
  end
end;

procedure TAQRCell.UpdateSizes;
begin
   UpdateCell;
   if FTopCell<>nil then
     Size.width:=FTopCell.Size.width*FTopCellProcent/100;
   if FLeftCell<>nil then
     Size.height:=FLeftCell.Size.height*FLeftCellProcent/100;
   SetNewSize(size.width,size.height,true);
end;

procedure TAQRCell.UpdateCell;
begin
   if (FLeftCell<>nil) and (FLeftCell.Parent<>Parent) then
     Parent:=FLeftCell.Parent;
   if FTopCell<>nil then
   begin
     if FTopCell.Parent<>Parent then
     begin
      if FLeftCell<>nil then
        SetNewPos(FLeftCell.size.Left+FLeftCell.size.Width,
            FLeftCell.Size.Top)
      else
        SetNewPos(FTopCell.size.Left, Size.Top);
    end
    else
    begin
      if FLeftCell<>nil then
        SetNewPos(FLeftCell.size.Left+FLeftCell.size.Width,
            FTopCell.Size.Top+FTopCell.Size.Height)
      else
        SetNewPos(FTopCell.size.Left,
            FTopCell.Size.Top+FTopCell.Size.Height);
    end;
  end
  else
  begin
     if FLeftCell<>nil then
        SetNewPos(FLeftCell.size.Left+FLeftCell.size.Width,
            FLeftCell.Size.Top);
   end;
end;

{$IFDEF WIN32}
procedure TAQRCell.SetTopCell(Cell:TAQRCell);
begin
  if Cell<>FTopCell then
  begin
    FTopCell:=Cell;
{$ELSE}
function TAQRCell.GetTopCell:TControl;
begin
  Result:=FTopCell;
end;
procedure TAQRCell.SetTopCell(Cell:TControl);
begin
  if (Cell<>nil) and not (Cell is TAQRCell) then
    Exit;
  if FTopCell<>TAQRCell(Cell) then
  begin
    FTopCell:=TAQRCell(Cell);
{$ENDIF}
    if FTopCell<>nil then
      SetNewSize(FTopCell.Size.width*FTopCellProcent/100,Size.Height,false);
    UpdateCell;
  end;
end;
{$IFDEF WIN32}
procedure TAQRCell.SetLeftCell(Cell:TAQRCell);
begin
  if Cell<>FLeftCell then
  begin
    FLeftCell:=Cell;
{$ELSE}
function TAQRCell.GetLeftCell:TControl;
begin
  Result:=FLeftCell;
end;
procedure TAQRCell.SetLeftCell(Cell:TControl);
begin
  if (Cell<>nil) and not (Cell is TAQRCell) then
    Exit;
  if FLeftCell<>TAQRCell(Cell) then
  begin
    FLeftCell:=TAQRCell(Cell);
{$ENDIF}
    if FLeftCell<>nil then
      SetNewSize(Size.Width,FLeftCell.Size.height*FLeftCellProcent/100,false);
    UpdateCell;
  end;
end;
procedure TAQRCell.SetTopCellProcent(pr:integer);
begin
  if (pr>0) and (FTopCellProcent<>pr) then
  begin
    FTopCellProcent:=pr;
    if FTopCell<>nil then
      SetNewSize(FTopCell.Size.width*pr/100,Size.Height,false);
  end;
end;
procedure TAQRCell.SetLeftCellProcent(pr:integer);
begin
  if (pr>0) and (FLeftCellProcent<>pr) then
  begin
    FLeftCellProcent:=pr;
    if FLeftCell<>nil then
      SetNewSize(Size.Width,FLeftCell.Size.height*pr/100,false);
  end;
end;

procedure TAQRCell.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseDown) then
    OnMouseDown(Self,Button,Shift,X,Y)
  else
    inherited MouseDown(Button,Shift,X,Y);
end;
procedure TAQRCell.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseMove) then
    OnMouseMove(Self,Shift,X,Y)
  else
    inherited MouseMove(Shift,X,Y);
end;
procedure TAQRCell.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseUp) then
    OnMouseUp(Self,Button,Shift,X,Y)
  else
    inherited MouseUp(Button,Shift,X,Y);
end;
procedure TAQRCell.SetNewSize(w,h:extended;flg:boolean);
var i:integer;
    wflg:boolean;
    hflg:boolean;
begin
  if FUpdateSizes then
    Exit;
  if flg then
  begin
    wflg:=true;
    hflg:=true;
  end
  else
  begin
  if (size.width=w) and (size.height=h) then
    Exit;
  wflg:=size.width<>w;
  hflg:=size.height<>h;
  end;
  FUpdateSizes:=true;
  try
    size.width:=w;
    size.height:=h;
    if Owner=nil then
      Exit;
    for i:=0 to Owner.ComponentCount-1 do
    begin
      if (Owner.Components[i] is TAQRMemo) then
      begin
        if TAQRMemo(Owner.Components[i]).InCell=Self then
          TAQRMemo(Owner.Components[i]).UpdateCell
      end
      else if Owner.Components[i] is TAQRLabel then
      begin
        if TAQRLabel(Owner.Components[i]).InCell=Self then
          TAQRLabel(Owner.Components[i]).UpdateCell;
      end
      else if Owner.Components[i] is TAQRCell then
      begin
        if (TAQRCell(Owner.Components[i]).TopCell=Self) or
           (TAQRCell(Owner.Components[i]).LeftCell=Self) then
        begin
          if wflg and (TAQRCell(Owner.Components[i]).TopCell=Self) then
             TAQRCell(Owner.Components[i]).SetNewSize(Size.width*TAQRCell(Owner.Components[i]).TopCellProcent/100,
                TAQRCell(Owner.Components[i]).Size.Height,false);
          if hflg and (TAQRCell(Owner.Components[i]).LeftCell=Self) then
             TAQRCell(Owner.Components[i]).SetNewSize(TAQRCell(Owner.Components[i]).Size.Width,
               Size.height*TAQRCell(Owner.Components[i]).LeftCellProcent/100,false);
          TAQRCell(Owner.Components[i]).UpdateCell;
        end;
      end;
    end;
  finally
    FUpdateSizes:=false;
  end;
end;
procedure TAQRCell.SetNewPos(x,y:extended);
var i:integer;
begin
  if FUpdateSizes then
    Exit;
  FUpdateSizes:=true;
  try
    size.left:=x;
    size.top:=y;
    if Owner=nil then
      Exit;
    for i:=0 to Owner.ComponentCount-1 do
    begin
      if (Owner.Components[i] is TAQRMemo) then
      begin
        if TAQRMemo(Owner.Components[i]).InCell=Self then
          TAQRMemo(Owner.Components[i]).UpdateCell
      end
      else if Owner.Components[i] is TAQRLabel then
      begin
        if TAQRLabel(Owner.Components[i]).InCell=Self then
          TAQRLabel(Owner.Components[i]).UpdateCell;
      end
      else if Owner.Components[i] is TAQRCell then
      begin
        if (TAQRCell(Owner.Components[i]).TopCell=Self) or
           (TAQRCell(Owner.Components[i]).LeftCell=Self) then
          TAQRCell(Owner.Components[i]).UpdateCell;
      end;
    end;
  finally
    FUpdateSizes:=false;
  end;
end;
{$ENDIF}

{ TAQRLabel }
constructor TAQRLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FFieldName:='';
  FFieldFormat:='';
  FAutoResize:=arNoChange;
{$IFDEF QR20}
  FInCell:=nil;
  FVShift:=0.5;
  FHShift:=1;
{$ENDIF}
end;
{$IFDEF QR20}
procedure TAQRLabel.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (Operation=opRemove) and not ReportSaving then
  begin
    if AComponent=FInCell then
      FInCell:=nil;
  end;
end;
procedure TAQRLabel.UpdateCell;
begin
  if FInCell=nil then
    Exit;
   Size.left:=FInCell.Size.Left+FHShift;
   Size.top:=FInCell.Size.top+FVShift;
   Size.Width:=FInCell.Size.Width-FHShift*2;
   Size.Height:=FInCell.Size.Height-FVShift*2;
end;
{$IFDEF WIN32}
procedure TAQRLabel.SetInCell(Cell:TAQRCell);
begin
  if FInCell<>Cell then
  begin
    FInCell:=Cell;
    UpdateCell;
  end;
end;
{$ELSE}
function TAQRLabel.GetInCell:TControl;
begin
  Result:=FInCell;
end;
procedure TAQRLabel.SetInCell(Cell:TControl);
begin
  if (Cell<>nil) and not (Cell is TAQRCell) then
    Exit;
  if FInCell<>TAQRCell(Cell) then
  begin
    FInCell:=TAQRCell(Cell);
    UpdateCell;
  end;
end;
{$ENDIF}
procedure TAQRLabel.SetHShift(a:extended);
begin
  if FHShift<>a then
  begin
    FHShift:=a;
    UpdateCell;
  end;
end;
procedure TAQRLabel.SetVShift(a:extended);
begin
  if FVShift<>a then
  begin
    FVShift:=a;
    UpdateCell;
  end;
end;
procedure TAQRLabel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseDown) then
    OnMouseDown(Self,Button,Shift,X,Y)
  else
    inherited MouseDown(Button,Shift,X,Y);
end;
procedure TAQRLabel.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseMove) then
    OnMouseMove(Self,Shift,X,Y)
  else
    inherited MouseMove(Shift,X,Y);
end;
procedure TAQRLabel.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseUp) then
    OnMouseUp(Self,Button,Shift,X,Y)
  else
    inherited MouseUp(Button,Shift,X,Y);
end;
{$ENDIF}

function TAQRLabel.FieldNameNotNull:boolean;
begin
  Result:=Length(FFieldName)<>0;
end;

function TAQRLabel.FieldFormatNotNull:boolean;
begin
  Result:=Length(FFieldFormat)<>0;
end;

{ TAQRMemo }

constructor TAQRMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FFieldName:='';
  FFieldFormat:='';
  FAutoResize:=arNoChange;
  AutoSize:=False;
{$IFDEF QR20}
  FInCell:=nil;
  FVShift:=0.5;
  FHShift:=1;
{$ENDIF}
end;
{$IFDEF QR20}
procedure TAQRMemo.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (Operation=opRemove) and not ReportSaving then
  begin
    if AComponent=FInCell then
      FInCell:=nil;
  end;
end;
procedure TAQRMemo.UpdateCell;
begin
  if FInCell=nil then
    Exit;
   Size.left:=FInCell.Size.Left+FHShift;
   Size.top:=FInCell.Size.top+FVShift;
   Size.Width:=FInCell.Size.Width-FHShift*2;
   Size.Height:=FInCell.Size.Height-FVShift*2;
end;
{$IFDEF WIN32}
procedure TAQRMemo.SetInCell(Cell:TAQRCell);
begin
  if FInCell<>Cell then
  begin
    FInCell:=Cell;
    UpdateCell;
  end;
end;
{$ELSE}
function TAQRMemo.GetInCell:TControl;
begin
  Result:=FInCell;
end;
procedure TAQRMemo.SetInCell(Cell:TControl);
begin
  if (Cell<>nil) and not (Cell is TAQRCell) then
    Exit;
  if FInCell<>TAQRCell(Cell) then
  begin
    FInCell:=TAQRCell(Cell);
    UpdateCell;
  end;
end;
{$ENDIF}
procedure TAQRMemo.SetHShift(a:extended);
begin
  if FHShift<>a then
  begin
    FHShift:=a;
    UpdateCell;
  end;
end;
procedure TAQRMemo.SetVShift(a:extended);
begin
  if FVShift<>a then
  begin
    FVShift:=a;
    UpdateCell;
  end;
end;

procedure TAQRMemo.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseDown) then
    OnMouseDown(Self,Button,Shift,X,Y)
  else
    inherited MouseDown(Button,Shift,X,Y);
end;
procedure TAQRMemo.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseMove) then
    OnMouseMove(Self,Shift,X,Y)
  else
    inherited MouseMove(Shift,X,Y);
end;
procedure TAQRMemo.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseUp) then
    OnMouseUp(Self,Button,Shift,X,Y)
  else
    inherited MouseUp(Button,Shift,X,Y);
end;
{$ENDIF}

function TAQRMemo.FieldNameNotNull:boolean;
begin
  Result:=Length(FFieldName)<>0;
end;

function TAQRMemo.FieldFormatNotNull:boolean;
begin
  Result:=Length(FFieldFormat)<>0;
end;

function TAQRMemo.GetTextHeight:integer;
var oldFont:TFont;
    TextBounds:TRect;
    BufLen: Word;
    I: Integer;
    StrEnd, StrTxt: PChar;
    StrBuf: array[0..255] of Char;
begin
  BufLen := 1;
  for I := 0 to Lines.Count - 1 do
    Inc(BufLen, Length(Lines.Strings[I]) + 1);
  StrTxt := StrAlloc(BufLen);
  try
    StrEnd := StrTxt;
    for I := 0 to Lines.Count - 1 do
    begin
      StrPCopy(StrBuf, Lines.Strings[I]);
      StrEnd := StrECopy(StrEnd, StrBuf);
      StrEnd := StrECopy(StrEnd, #10);
    end;
    with (Owner as TForm) do
    begin
      OldFont:=Canvas.Font;
      Canvas.Font:=Self.Font;
      TextBounds := Rect(0, 0, Self.ClientWidth, 0);
      DrawText(Canvas.Handle, StrTxt, -1, TextBounds, DT_CALCRECT);
      Canvas.Font:=oldFont;
    end;
    Result:=TextBounds.Bottom;
  finally
    StrDispose(StrTxt);
  end;
end;

{$IFDEF QR20}
{ TAQRImage }

constructor TAQRImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAutoResize:=arNoChange;
end;

procedure TAQRImage.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseDown) then
    OnMouseDown(Self,Button,Shift,X,Y)
  else
    inherited MouseDown(Button,Shift,X,Y);
end;
procedure TAQRImage.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseMove) then
    OnMouseMove(Self,Shift,X,Y)
  else
    inherited MouseMove(Shift,X,Y);
end;
procedure TAQRImage.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseUp) then
    OnMouseUp(Self,Button,Shift,X,Y)
  else
    inherited MouseUp(Button,Shift,X,Y);
end;
{$ENDIF}

{ TAQRShape }

constructor TAQRShape.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAutoResize:=arNoChange;
end;

{$IFDEF QR20}
procedure TAQRShape.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseDown) then
    OnMouseDown(Self,Button,Shift,X,Y)
  else
    inherited MouseDown(Button,Shift,X,Y);
end;
procedure TAQRShape.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseMove) then
    OnMouseMove(Self,Shift,X,Y)
  else
    inherited MouseMove(Shift,X,Y);
end;
procedure TAQRShape.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseUp) then
    OnMouseUp(Self,Button,Shift,X,Y)
  else
    inherited MouseUp(Button,Shift,X,Y);
end;
{$ENDIF}

{ TAQRBand }

{$IFDEF QR20}
procedure TAQRBand.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseDown) then
    OnMouseDown(Self,Button,Shift,X,Y)
  else
    inherited MouseDown(Button,Shift,X,Y);
end;
procedure TAQRBand.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseMove) then
    OnMouseMove(Self,Shift,X,Y)
  else
    inherited MouseMove(Shift,X,Y);
end;
procedure TAQRBand.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Assigned(OnMouseUp) then
    OnMouseUp(Self,Button,Shift,X,Y)
  else
    inherited MouseUp(Button,Shift,X,Y);
end;
{$ENDIF}

procedure TAQRBand.SetHeightAutoResize(NewHeight:integer);
var d,i:integer;
begin
  d:=NewHeight-Height;
  if d=0 then Exit;
  Height:=NewHeight;
  for i:=0 to ControlCount-1 do
  begin
    if Controls[i] is TAQRLabel then
    begin
      with Controls[i] as TAQRLabel do
      begin
{$IFDEF QR20}
        if InCell=nil then
{$ENDIF}
        case AutoResize of
          arChangePos: Top:=Top+d;
          arChangeSize: Height:=Height+d;
        end;
      end;
    end
    else if Controls[i] is TAQRMemo then
    begin
      with Controls[i] as TAQRMemo do
      begin
{$IFDEF QR20}
        if InCell=nil then
{$ENDIF}
        case AutoResize of
          arChangePos: Top:=Top+d;
          arChangeSize: Height:=Height+d;
        end;
      end;
    end
    else if Controls[i] is TAQRShape then
    begin
      with Controls[i] as TAQRShape do
      begin
        case AutoResize of
          arChangePos: Top:=Top+d;
          arChangeSize: Height:=Height+d;
        end;
      end;
    end
{$IFDEF QR20}
    else if Controls[i] is TAQRImage then
    begin
      with Controls[i] as TAQRImage do
      begin
        case AutoResize of
          arChangePos: Top:=Top+d;
          arChangeSize: Height:=Height+d;
        end;
      end;
    end
    else if Controls[i] is TAQRCell then
    begin
      with Controls[i] as TAQRCell do
      begin
        if (LeftCell=nil) and ((TopCell=nil) or (TopCell.Parent<>Parent)) then
        begin
          case AutoResize of
            arChangePos: Top:=Top+d;
            arChangeSize: Height:=Height+d;
          end;
          UpdateSizes;
        end;
      end;
    end;
{$ENDIF}
  end;
end;

function TAQRBand.GetHeightAutoResize:integer;
begin
  Result:=Height;
end;

{ TAQREditorFields }

constructor TAQREditorFields.Create(AOwner: TComponent);
var i:integer;
begin
  inherited Create(AOwner);
  FFieldNames:=TStringList.Create;
  FFieldFormats:=TStringList.Create;
end;

destructor TAQREditorFields.Destroy;
begin
  FFieldNames.Free;
  FFieldFormats.Free;
  inherited Destroy;
end;
procedure TAQREditorFields.SetFieldNames(Value:TStrings);
begin
  FFieldNames.Assign(Value);
end;

procedure TAQREditorFields.SetFieldFormats(Value:TStrings);
begin
  FFieldFormats.Assign(Value);
end;

{ TAQREditor }

constructor TAQREditor.Create(AOwner: TComponent);
var i:integer;
begin
  inherited Create(AOwner);
  FFieldDefs:=nil;
  if AOwner is TForm then
    with TForm(AOwner) do
      for i:=0 to ComponentCount-1 do
        if Components[i] is TAQREditorFields then
        begin
          FFieldDefs:=TAQREditorFields(Components[i]);
          break;
        end;
  MainMenu:=nil;
  PopupMenu:=nil;
  MoveControl:=nil;
  FrameControl:=TShape.Create(Self);
  with FrameControl do
  begin
    Brush.Style:=bsClear;
    Pen.Color:=clRed;
    Parent:=nil;
  end;
end;

procedure TAQREditor.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if not ReportSaving then
  begin
    if (Operation=opRemove) then
    begin
      if AComponent=FFieldDefs then
        FFieldDefs:=nil;
    end
    else if (Operation=opInsert) then
    begin
      if (FFieldDefs=nil) and (AComponent is TAQREditorFields) then
        FFieldDefs:=TAQREditorFields(AComponent);
    end
  end;
end;

destructor TAQREditor.Destroy;
begin
  if owner<>nil then
  begin
    disableEdit;
    with Owner as TForm do
      if Menu=MainMenu then
        Menu:=nil;
  end;
  inherited Destroy;
end;

procedure TAQREditor.GetFormats(Sender: TObject);
Var lblfmt,lblfld: TComboBox;
    i,l:integer;
    fmt:string[4];
begin
  lblfld:=(Sender as TComboBox);
  lblfmt:=(lblfld.Owner.FindComponent('LabelFormat')) as TComboBox;
  lblfmt.items.Clear;
  fmt:='';
  if FFieldDefs<>nil then
  begin
    with FFieldDefs.FFieldNames do
      for i:=0 to count-1 do
      begin
        l:=Pos(':',Strings[i]);
        if l=0 then
          l:=Length(Strings[i])
        else
          Dec(l);
        if Copy(Strings[i],1,L)=lblfld.text then
        begin
          fmt:=Copy(Strings[i],L+2,4);
          break;
        end;
      end;
    with FFieldDefs.FFieldFormats do
      for i:=0 to count-1 do
      begin
        l:=Pos(':',Strings[i]);
        if l<>0 then
          if Copy(Strings[i],1,L-1)=fmt then
          begin
            lblfmt.items.Add(Copy(Strings[i],L+1,100));
          end;
      end;
  end;
  if Assigned(FOnGetFieldFormats) then
    FOnGetFieldFormats(Self,lblfld.text,lblfmt.items);
end;

procedure TAQREditor.EditControl(Sender: TControl);
var lbl:TAQRLabel;
    shp:TAQRShape;
{$IFDEF QR20}
    img:TAQRImage;
    cel:TAQRCell;
{$ENDIF}
    mem:TAQRMemo;
    i,l:integer;
begin
  if Sender is TAQRLabel then
  begin
    lbl:=(Sender as TAQRLabel);
    if QRLabelSetupFrm=nil then
      Application.CreateForm(TQRLabelSetupFrm, QRLabelSetupFrm);
    with QRLabelSetupFrm do
    begin
      labeltext.text:=lbl.Caption;
      FontSetup.Font:=lbl.Font;
      {$IFDEF QR20}
      labelleft.text:=FloattostrF(lbl.size.left,ffFixed,8,1);
      labeltop.text:=FloattostrF(lbl.size.top,ffFixed,8,1);
      labelwidth.text:=FloattostrF(lbl.size.width,ffFixed,8,1);
      labelheight.text:=FloattostrF(lbl.size.height,ffFixed,8,1);
      {$ELSE}
      labelleft.text:=inttostr(lbl.left);
      labeltop.text:=inttostr(lbl.top);
      labelwidth.text:=inttostr(lbl.width);
      labelheight.text:=inttostr(lbl.height);
      {$ENDIF}
      autoResizeMode.Text:=autoResizeMode.Items[ord(lbl.AutoResize)];
      labelfield.text:=lbl.fieldname;
      labelformat.text:=lbl.fieldformat;
      labeltransporent.checked:=lbl.transparent;
      labelautosize.checked:=lbl.autosize;
      labelaligment.itemindex:=ord(lbl.alignment);
      labelfield.items.Clear;
      if FFieldDefs<>nil then
      with FFieldDefs.FFieldNames do
        for i:=0 to count-1 do
        begin
          l:=Pos(':',Strings[i]);
          if l=0 then
            l:=Length(Strings[i])
          else
            Dec(l);
          labelfield.items.Add(Copy(Strings[i],1,L));
        end;
      if Assigned(FOnGetFieldNames) then
        FOnGetFieldNames(Self,labelfield.items);
      labelfield.onExit:=Self.GetFormats;
      GetFormats(labelField);
      ShowModal;
      labelfield.onExit:=nil;
      if ModalResult=mrOk then
      begin
        lbl.Font:=FontSetup.Font;
        {$IFDEF QR20}
        lbl.size.left:=strtoFloat(labelleft.text);
        lbl.size.top:=strtoFloat(labeltop.text);
        lbl.size.width:=strtoFloat(labelwidth.text);
        lbl.size.height:=strtoFloat(labelheight.text);
        {$ELSE}
        lbl.left:=strtoint(labelleft.text);
        lbl.top:=strtoint(labeltop.text);
        lbl.width:=strtoint(labelwidth.text);
        lbl.height:=strtoint(labelheight.text);
        {$ENDIF}
        lbl.AutoResize:=TAutoResizeType(autoResizeMode.Items.Indexof(autoResizeMode.Text));
        lbl.autosize:=labelautosize.checked;
        lbl.fieldname:=labelfield.text;
        lbl.fieldformat:=labelformat.text;
        lbl.transparent:=labeltransporent.checked;
        lbl.alignment:=Talignment(labelaligment.itemindex);
        lbl.caption:=labeltext.text;
        lbl.UpdateCell;
      end;
    end;
  end
  else if Sender is TAQRShape then
  begin
    shp:=(Sender as TAQRShape);
    if QRShapeSetupFrm=nil then
      Application.CreateForm(TQRShapeSetupFrm, QRShapeSetupFrm);
    with QRShapeSetupFrm do
    begin
    {$IFDEF QR20}
      shapeleft.text:=FloattostrF(shp.size.left,ffFixed,8,1);
      shapetop.text:=FloattostrF(shp.size.top,ffFixed,8,1);
      shapewidth.text:=FloattostrF(shp.size.width,ffFixed,8,1);
      shapeheight.text:=FloattostrF(shp.size.height,ffFixed,8,1);
    {$ELSE}
      shapeleft.text:=inttostr(shp.left);
      shapetop.text:=inttostr(shp.top);
      shapewidth.text:=inttostr(shp.width);
      shapeheight.text:=inttostr(shp.height);
    {$ENDIF}
      autoResizeMode.Text:=autoResizeMode.Items[ord(shp.AutoResize)];
      shapeStyle.itemindex:=ord(shp.shape);
      PenColor.Brush.Color:=shp.pen.color;
      BrushColor.Brush.Color:=shp.Brush.color;
      PenWidth.text:=inttostr(shp.pen.width);
      PenStyle:=shp.pen.style;
      BrushStyle:=shp.brush.style;
      ShowModal;
      if ModalResult=mrOk then
      begin
    {$IFDEF QR20}
        shp.size.left:=strtoFloat(shapeleft.text);
        shp.size.top:=strtoFloat(shapetop.text);
        shp.size.width:=strtoFloat(shapewidth.text);
        shp.size.height:=strtoFloat(shapeheight.text);
    {$ELSE}
        shp.left:=strtoint(shapeleft.text);
        shp.top:=strtoint(shapetop.text);
        shp.width:=strtoint(shapewidth.text);
        shp.height:=strtoint(shapeheight.text);
    {$ENDIF}
        shp.AutoResize:=TAutoResizeType(autoResizeMode.Items.Indexof(autoResizeMode.Text));
        shp.shape:=TQRShapeType(shapeStyle.itemindex);
        shp.pen.color:=PenColor.Brush.Color;
        shp.Brush.color:=BrushColor.Brush.Color;
        shp.pen.style:=PenStyle;
        shp.brush.style:=BrushStyle;
        shp.pen.width:=strtoint(penwidth.text);
      end;
    end;
  end
{$IFDEF QR20}
  else if Sender is TAQRImage then
  begin
    img:=(Sender as TAQRImage);
    if QRImageSetupFrm=nil then
      Application.CreateForm(TQRImageSetupFrm, QRImageSetupFrm);
    with QRImageSetupFrm do
    begin
      shapeleft.text:=FloattostrF(img.size.left,ffFixed,8,1);
      shapetop.text:=FloattostrF(img.size.top,ffFixed,8,1);
      shapewidth.text:=FloattostrF(img.size.width,ffFixed,8,1);
      shapeheight.text:=FloattostrF(img.size.height,ffFixed,8,1);
      autoResizeMode.Text:=autoResizeMode.Items[ord(img.AutoResize)];
      ImageAutoSize.Checked:=img.Autosize;
      ImageCenter.Checked:=img.Center;
      ImageStretch.Checked:=img.Stretch;
      Image1.Picture.Assign(img.Picture);
      ShowModal;
      if ModalResult=mrOk then
      begin
        img.size.left:=strtoFloat(shapeleft.text);
        img.size.top:=strtoFloat(shapetop.text);
        img.size.width:=strtoFloat(shapewidth.text);
        img.size.height:=strtoFloat(shapeheight.text);
        img.AutoResize:=TAutoResizeType(autoResizeMode.Items.Indexof(autoResizeMode.Text));
        img.Autosize:=ImageAutoSize.Checked;
        img.Center:=ImageCenter.Checked;
        img.Stretch:=ImageStretch.Checked;
        img.Picture.Assign(Image1.Picture);
      end;
    end;
  end
  else if Sender is TAQRCell then
  begin
    cel:=(Sender as TAQRCell);
    if QRCellSetupFrm=nil then
      Application.CreateForm(TQRCellSetupFrm, QRCellSetupFrm);
    with QRCellSetupFrm do
    begin
      shapeleft.text:=FloattostrF(cel.size.left,ffFixed,8,1);
      shapetop.text:=FloattostrF(cel.size.top,ffFixed,8,1);
      shapewidth.text:=FloattostrF(cel.size.width,ffFixed,8,1);
      shapeheight.text:=FloattostrF(cel.size.height,ffFixed,8,1);
      leftprocent.text:=inttostr(cel.leftcellprocent);
      topprocent.text:=inttostr(cel.topcellprocent);
      autoResizeMode.Text:=autoResizeMode.Items[ord(cel.AutoResize)];
      PenColor.Brush.Color:=cel.Frame.color;
      BrushColor.Brush.Color:=cel.Brush.color;
      PenWidth.text:=inttostr(cel.Frame.width);
      PenStyle:=cel.Frame.style;
      BrushStyle:=cel.brush.style;
      CheckBox1.Checked:=cel.Frame.DrawTop;
      CheckBox2.Checked:=cel.Frame.DrawLeft;
      CheckBox3.Checked:=cel.Frame.DrawBottom;
      CheckBox4.Checked:=cel.Frame.DrawRight;
      ShowModal;
      if ModalResult=mrOk then
      begin
        cel.size.left:=strtoFloat(shapeleft.text);
        cel.size.top:=strtoFloat(shapetop.text);
        cel.size.width:=strtoFloat(shapewidth.text);
        cel.size.height:=strtoFloat(shapeheight.text);
        cel.leftcellprocent:=strtoint(leftprocent.text);
        cel.topcellprocent:=strtoint(topprocent.text);
        cel.AutoResize:=TAutoResizeType(autoResizeMode.Items.Indexof(autoResizeMode.Text));
        cel.Frame.color:=PenColor.Brush.Color;
        cel.Brush.color:=BrushColor.Brush.Color;
        cel.Frame.style:=PenStyle;
        cel.brush.style:=BrushStyle;
        cel.Frame.width:=strtoint(penwidth.text);
        cel.Frame.DrawTop:=CheckBox1.Checked;
        cel.Frame.DrawLeft:=CheckBox2.Checked;
        cel.Frame.DrawBottom:=CheckBox3.Checked;
        cel.Frame.DrawRight:=CheckBox4.Checked;
        cel.UpdateSizes;
      end;
    end;
  end
{$ENDIF}
  else if Sender is TAQRMemo then
  begin
    mem:=(Sender as TAQRMemo);
    if QRMemoSetupFrm=nil then
      Application.CreateForm(TQRMemoSetupFrm, QRMemoSetupFrm);
    with QRMemoSetupFrm do
    begin
      labeltext.Lines.clear;
      labeltext.Lines.addStrings(mem.Lines);
      FontSetup.Font:=mem.Font;
      {$IFDEF QR20}
      labelleft.text:=FloattostrF(mem.size.left,ffFixed,8,1);
      labeltop.text:=FloattostrF(mem.size.top,ffFixed,8,1);
      labelwidth.text:=FloattostrF(mem.size.width,ffFixed,8,1);
      labelheight.text:=FloattostrF(mem.size.height,ffFixed,8,1);
      {$ELSE}
      labelleft.text:=inttostr(mem.left);
      labeltop.text:=inttostr(mem.top);
      labelwidth.text:=inttostr(mem.width);
      labelheight.text:=inttostr(mem.height);
      {$ENDIF}
      autoResizeMode.Text:=autoResizeMode.Items[ord(mem.AutoResize)];
      labelfield.text:=mem.fieldname;
      labelformat.text:=mem.fieldformat;
      labelfield.items.Clear;
      if Assigned(FOnGetFieldNames) then
        FOnGetFieldNames(Self,labelfield.items);
      labelfield.onExit:=Self.GetFormats;
      GetFormats(labelField);
      ShowModal;
      labelfield.onExit:=nil;
      if ModalResult=mrOk then
      begin
        mem.Font:=FontSetup.Font;
        {$IFDEF QR20}
        mem.size.left:=strtoFloat(labelleft.text);
        mem.size.top:=strtoFloat(labeltop.text);
        mem.size.width:=strtoFloat(labelwidth.text);
        mem.size.height:=strtoFloat(labelheight.text);
        {$ELSE}
        mem.left:=strtoint(labelleft.text);
        mem.top:=strtoint(labeltop.text);
        mem.width:=strtoint(labelwidth.text);
        mem.height:=strtoint(labelheight.text);
        {$ENDIF}
        mem.AutoResize:=TAutoResizeType(autoResizeMode.Items.Indexof(autoResizeMode.Text));
        mem.fieldname:=labelfield.text;
        mem.fieldformat:=labelformat.text;
        mem.Lines.clear;
        mem.Lines.addStrings(labeltext.Lines);
        mem.UpdateCell;
      end;
    end;
  end
  else if Sender is TAQRBand then
  begin
    if QRBandSetupFrm=nil then
      Application.CreateForm(TQRBandSetupFrm, QRBandSetupFrm);
    with QRBandSetupFrm do
    begin
      {$IFDEF QR20}
        BandHeight.text:=FloatToStrF((Sender as TAQRBand).Height/3.8,ffFixed,8,1);
      {$ELSE}
        BandHeight.text:=intToStr(((Sender as TAQRBand).Height*10+37) div 38);
      {$ENDIF}
      FontSetup.Font:=(Sender as TAQRBand).Font;
      ShowModal;
      if ModalResult=mrOk then
      begin
        (Sender as TAQRBand).Font:=FontSetup.Font;
      {$IFDEF QR20}
        (Sender as TAQRBand).HeightAutoResize:=round(strToFloat(BandHeight.text)*3.8);
      {$ELSE}
        (Sender as TAQRBand).HeightAutoResize:=(strToint(BandHeight.text)*38) div 10;
      {$ENDIF}
      end;
    end;
  end
end;

procedure TAQREditor.ControlMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if MoveControl<>nil then
  begin
    if MoveControl is TAQRLabel then
      FrameControl.Parent:=nil;
{$IFDEF QR20}
    if MoveControl is TAQRCell then
      TAQRCell(MoveControl).UpdateSizes
    else if MoveControl is TAQRLabel then
      TAQRLabel(MoveControl).UpdateCell
    else if MoveControl is TAQRMemo then
      TAQRMemo(MoveControl).UpdateCell;
{$ENDIF}
    Screen.Cursor:=crDefault;
    MoveControl:=nil;
  end;
end;

procedure TAQREditor.ControlMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pt:Tpoint;
    pr:TWinControl;
    i,eps:integer;
    flg:boolean;
{$IFDEF QR20}
    cel:TAQRCell;
{$ENDIF}
begin
  if button=mbRight then
  begin
    editMode:=0;
    PopupControl:=(Sender as TControl);
    pt.x:=x;
    pt.y:=y;
    pt:=PopupControl.ClientToScreen(pt);
    flg:=PopupControl is TAQRCell;
    PopupMenu.Items[5].Enabled:=flg;
    PopupMenu.Items[6].Enabled:=flg;
    PopupMenu.Popup(pt.x,pt.y);
  end
  else if (editMode=1) and (button=mbLeft) then
  begin
    if not (Sender is TAQRBand) then
    begin
      MoveControl:=(sender as Tcontrol);
      pt.x:=x;
      pt.y:=y;
      pt:=MoveControl.ClientToScreen(pt);
      MoveX:=pt.X;
      MoveY:=pt.Y;
      if MoveControl is TAQRLabel then
      begin
        FrameControl.SetBounds(MoveControl.Left,MoveControl.Top,
            MoveControl.Width,MoveControl.height);
        FrameControl.Parent:=MoveControl.Parent;
      end;
      with MoveControl do
      begin
        moveRect.Top:=top;
        moveRect.bottom:=Height+Top-1;
        moveRect.Left:=left;
        moveRect.Right:=Width+Left-1;
      end;
      eps:=3;
      if MoveControl is TAQRMemo then
        eps:=7;
      movemode:=0;
      if (abs(y - Movecontrol.height)<=eps) and
        (abs(x - Movecontrol.width)<=eps) then
          MoveMode:=3
      else if (abs(y - Movecontrol.height div 2)<=3) and
        (abs(x - Movecontrol.width)<=eps) then
          MoveMode:=1
      else if (abs(y - Movecontrol.height)<=eps) and
        (abs(x - Movecontrol.width div 2)<=3) then
          MoveMode:=2;
      if movemode=1 then
        Screen.Cursor:=crSizeWE
      else if movemode=2 then
        Screen.Cursor:=crSizeNS
      else if movemode=3 then
        Screen.Cursor:=crSizeNWSE
      else
        Screen.Cursor:=crDrag;
    end;
  end
  else if (editMode=2) and (button=mbLeft) then
  begin
    if not (Sender is TAQRBand) then
    begin
      Sender.Free;
      EditMode:=0;
    end;
  end
  else if (editMode=5) and (button=mbLeft) then
  begin
    EditControl(sender as Tcontrol);
    EditMode:=0;
  end
  else if (editMode=3) and (button=mbLeft) then
  begin
    EditMode:=0;
    pr:=TWinControl(Sender);
    if not (Sender is TAQRBand) then
      pr:=(Sender as TControl).Parent;
{$IFDEF QR20}
    cel:=nil;
    if (Sender is TAQRCell) then
      cel:=TAQRCell(Sender);
{$ENDIF}
    pt.x:=x;
    pt.y:=y;
    pt:=(Sender as TControl).ClientToScreen(pt);
    pt:=pr.ScreenToClient(pt);
    if CreateClass=2 then
    begin
      i:=1;
      while Owner.FindComponent('QRShape'+inttostr(i))<>nil do
        i:=i+1;
      with TAQRShape.Create(Owner) do
      begin
        left:=pt.x;
        top:=pt.y;
        Name:='QRShape'+inttostr(i);
        Parent:=pr;
        OnMouseDown:=ControlMouseDown;
        OnMouseUp:=ControlMouseUp;
        OnMouseMove:=ControlMouseMove;
      end
    end
{$IFDEF QR20}
    else if CreateClass=5 then
    begin
      i:=1;
      while Owner.FindComponent('QRImage'+inttostr(i))<>nil do
        i:=i+1;
      with TAQRImage.Create(Owner) do
      begin
        left:=pt.x;
        top:=pt.y;
        Name:='QRImage'+inttostr(i);
        Parent:=pr;
        OnMouseDown:=ControlMouseDown;
        OnMouseUp:=ControlMouseUp;
        OnMouseMove:=ControlMouseMove;
      end
    end
    else if CreateClass=4 then
    begin
      i:=1;
      while Owner.FindComponent('QRCell'+inttostr(i))<>nil do
        i:=i+1;
      with TAQRCell.Create(Owner) do
      begin
        left:=pt.x;
        top:=pt.y;
        Name:='QRCell'+inttostr(i);
        Parent:=pr;
        OnMouseDown:=ControlMouseDown;
        OnMouseUp:=ControlMouseUp;
        OnMouseMove:=ControlMouseMove;
        LeftCell:=cel;
        Tie;
      end
    end
 {$ENDIF}
    else if CreateClass=3 then
    begin
      i:=1;
      while Owner.FindComponent('QRMemo'+inttostr(i))<>nil do
        i:=i+1;
      with TAQRMemo.Create(Owner) do
      begin
        left:=pt.x;
        top:=pt.y;
        Name:='QRMemo'+inttostr(i);
        Parent:=pr;
        OnMouseDown:=ControlMouseDown;
        OnMouseUp:=ControlMouseUp;
        OnMouseMove:=ControlMouseMove;
{$IFDEF QR20}
        if cel<>nil then
          AutoSize:=false;
        InCell:=cel;
{$ENDIF}
      end
    end
    else if CreateClass=1 then
    begin
      i:=1;
      while Owner.FindComponent('QRLabel'+inttostr(i))<>nil do
        i:=i+1;
      with TAQRLabel.Create(Owner) do
      begin
        left:=pt.x;
        top:=pt.y;
        Name:='QRLabel'+inttostr(i);
        Caption:=Name;
        Parent:=pr;
        OnMouseDown:=ControlMouseDown;
        OnMouseUp:=ControlMouseUp;
        OnMouseMove:=ControlMouseMove;
{$IFDEF QR20}
        if cel<>nil then
          AutoSize:=false;
        InCell:=cel;
{$ENDIF}
      end
    end
  end
end;

procedure TAQREditor.ControlMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: Integer);
var pt:TPoint;
    newx,newy,neww,newh,x2,y2:integer;
begin
  if MoveControl<>nil then
  begin
    pt.x:=x;
    pt.y:=y;
    pt:=(Sender as TControl).ClientToScreen(pt);
    case moveMode of
    0: begin
        newx:=MoveRect.left+pt.X-MoveX;
        newy:=MoveRect.top+pt.Y-MoveY;
        neww:=MoveRect.right-MoveRect.left+1;
        newh:=MoveRect.bottom-MoveRect.top+1;
      end;
    1: begin
        newx:=MoveRect.left;
        newy:=MoveRect.top;
        neww:=MoveRect.right-MoveRect.left+1+pt.X-MoveX;
        newh:=MoveRect.bottom-MoveRect.top+1;
      end;
    2: begin
        newx:=MoveRect.left;
        newy:=MoveRect.top;
        neww:=MoveRect.right-MoveRect.left+1;
        newh:=MoveRect.bottom-MoveRect.top+1+pt.Y-MoveY;
      end;
    3: begin
        newx:=MoveRect.left;
        newy:=MoveRect.top;
        neww:=MoveRect.right-MoveRect.left+1+pt.X-MoveX;
        newh:=MoveRect.bottom-MoveRect.top+1+pt.Y-MoveY;
      end;
    end;
    if neww<3 then
      neww:=3;
    if newh<3 then
      newh:=3;
    if newx<0 then
      newx:=0;
    if newy<0 then
      newy:=0;
    x2:=newx+neww;
    y2:=newy+newh;
    if (newx<MoveControl.Parent.Width-1) and
       (newy<MoveControl.Parent.height-1) and
       (x2>0) and (y2>0) then
    begin
      MoveControl.SetBounds(newx,newy,neww,newh);
      if MoveControl is TAQRLabel then
        FrameControl.SetBounds(newx,newy,neww,newh);
    end;
  end
end;

procedure TAQREditor.EnableEdit;
var i:integer;
begin
  EditMode:=0;
  moveControl:=nil;
  popupControl:=nil;
  with Owner do
  begin
  for i:=0 to ComponentCount-1 do
  if Components[i] is TAQRLabel then
    with Components[i] as TAQRLabel do
    begin
       OnMouseDown:=ControlMouseDown;
       OnMouseUp:=ControlMouseUp;
       OnMouseMove:=ControlMouseMove;
    end
  else if Components[i] is TAQRShape then
    with Components[i] as TAQRShape do
    begin
       OnMouseDown:=ControlMouseDown;
       OnMouseUp:=ControlMouseUp;
       OnMouseMove:=ControlMouseMove;
    end
{$IFDEF QR20}
  else if Components[i] is TAQRImage then
    with Components[i] as TAQRImage do
    begin
       OnMouseDown:=ControlMouseDown;
       OnMouseUp:=ControlMouseUp;
       OnMouseMove:=ControlMouseMove;
    end
  else if Components[i] is TAQRCell then
    with Components[i] as TAQRCell do
    begin
       OnMouseDown:=ControlMouseDown;
       OnMouseUp:=ControlMouseUp;
       OnMouseMove:=ControlMouseMove;
    end
{$ENDIF}
  else if Components[i] is TAQRMemo then
    with Components[i] as TAQRMemo do
    begin
       OnMouseDown:=ControlMouseDown;
       OnMouseUp:=ControlMouseUp;
       OnMouseMove:=ControlMouseMove;
    end
  else if Components[i] is TAQRBand then
    with Components[i] as TAQRBand do
    begin
       OnMouseDown:=ControlMouseDown;
       OnMouseUp:=ControlMouseUp;
       OnMouseMove:=ControlMouseMove;
    end;
  end;
end;

procedure TAQREditor.DisableEdit;
var i:integer;
begin
  EditMode:=0;
  moveControl:=nil;
  popupControl:=nil;
  if Owner=nil then Exit;
  with Owner do
  begin
  for i:=0 to ComponentCount-1 do
  if Components[i] is TAQRLabel then
    with Components[i] as TAQRLabel do
    begin
       OnMouseDown:=nil;
       OnMouseUp:=nil;
       OnMouseMove:=nil;
    end
  else if Components[i] is TAQRShape then
    with Components[i] as TAQRShape do
    begin
       OnMouseDown:=nil;
       OnMouseUp:=nil;
       OnMouseMove:=nil;
    end
{$IFDEF QR20}
  else if Components[i] is TAQRImage then
    with Components[i] as TAQRImage do
    begin
       OnMouseDown:=nil;
       OnMouseUp:=nil;
       OnMouseMove:=nil;
    end
  else if Components[i] is TAQRCell then
    with Components[i] as TAQRCell do
    begin
       OnMouseDown:=nil;
       OnMouseUp:=nil;
       OnMouseMove:=nil;
    end
{$ENDIF}
  else if Components[i] is TAQRMemo then
    with Components[i] as TAQRMemo do
    begin
       OnMouseDown:=nil;
       OnMouseUp:=nil;
       OnMouseMove:=nil;
    end
  else if Components[i] is TAQRBand then
    with Components[i] as TAQRBand do
    begin
       OnMouseDown:=nil;
       OnMouseUp:=nil;
       OnMouseMove:=nil;
    end;
  end;
end;

procedure TAQREditor.FileCloseClick(Sender: TObject);
begin
  (Owner as TForm).Close;
  DisableEdit;
  (Owner as TForm).Menu:=nil;
end;

procedure TAQREditor.EditDeleteClick(Sender: TObject);
begin
  EditMode:=2;
end;

procedure TAQREditor.EditMoveClick(Sender: TObject);
begin
  EditMode:=1;
end;

procedure TAQREditor.FileSaveClick(Sender: TObject);
Var Form,Tmp:TForm;
    oldVis:Boolean;
    i:integer;
    cmnt:TComponent;
begin
  Form:=Owner as TForm;
  DisableEdit;
  Application.CreateForm(TForm,Tmp);
  try
    ReportSaving:=true;
    with Form do
    begin
      i:=0;
      while i<ComponentCount do
      begin
        if (Components[i] is TAQREditorFields) or
{$IFDEF QR20}
          (Components[i] is TQuickRep) or
          (Components[i] is TQRCustomBand) or
          (Components[i] is TQRPrintable) then
{$ELSE}
          (Components[i] is TQuickReport) or
          (Components[i] is TQRBand) or
          (Components[i] is TQRLabel) or
          (Components[i] is TQRMemo) or
          (Components[i] is TQRShape) then
{$ENDIF}
        begin
          cmnt:=Form.Components[i];
          Form.RemoveComponent(cmnt);
          Tmp.InsertComponent(cmnt);
          if cmnt is TControl then
            if TControl(cmnt).Parent=Form then
               TControl(cmnt).Parent:=Tmp;
        end
        else
          inc(i);
      end;
    end;
    WriteComponentResFile(FFileName,Tmp);
    while Tmp.ComponentCount>0 do
    begin
      cmnt:=Tmp.Components[0];
      Tmp.RemoveComponent(cmnt);
      Form.InsertComponent(cmnt);
      if cmnt is TControl then
        if TControl(cmnt).Parent=Tmp then
           TControl(cmnt).Parent:=Form;
{$IFDEF QR20}
        if (cmnt is TQuickRep) then
          with TQuickRep(cmnt) do
          begin
            Left:=0;
            Top:=0;
          end;
{$ENDIF}
    end;
  finally
    Tmp.Free;
    ReportSaving:=false;
  end;
  EnableEdit;
end;

procedure TAQREditor.LoadReport;
Var Form,Tmp:TForm;
    oldVis:Boolean;
    i:integer;
    cmnt:TComponent;
begin
  if FileExists(FFileName) then
  begin
    Form:=(Owner as TForm);
    with Form do
    begin
      i:=0;
      while i<ComponentCount do
      begin
        if (Components[i] is TAQREditorFields) or
{$IFDEF QR20}
          (Components[i] is TQuickRep) or
          (Components[i] is TQRCustomBand) or
          (Components[i] is TQRPrintable) then
{$ELSE}
          (Components[i] is TQuickReport) or
          (Components[i] is TQRBand) or
          (Components[i] is TQRLabel) or
          (Components[i] is TQRMemo) or
          (Components[i] is TQRShape) then
{$ENDIF}
          Components[i].Free
        else
          inc(i);
      end;
    end;
    Application.CreateForm(TForm,Tmp);
    try
      ReportSaving:=true;
      ReadComponentResFile(FFileName,Tmp);
      while Tmp.ComponentCount>0 do
      begin
        cmnt:=Tmp.Components[0];
        Tmp.RemoveComponent(cmnt);
        Form.InsertComponent(cmnt);
        if cmnt is TControl then
          if TControl(cmnt).Parent=Tmp then
             TControl(cmnt).Parent:=Form;
{$IFDEF QR20}
        if (cmnt is TQuickRep) then
          with TQuickRep(cmnt) do
          begin
            Left:=0;
            Top:=0;
          end;
{$ENDIF}
      end;
    finally
      Tmp.Free;
      ReportSaving:=false;
    end;
    with Form do
      for i:=0 to ComponentCount-1 do
        if Components[i] is TAQREditorFields then
        begin
          FFieldDefs:=TAQREditorFields(Components[i]);
          break;
        end;
  end;
end;

procedure TAQREditor.FileOpenClick(Sender: TObject);
Var Form:TForm;
begin
  Form:=Owner as TForm;
  LoadReport;
  EnableEdit;
end;

procedure TAQREditor.PopupMoveClick(Sender: TObject);
begin
  EditMode:=1;
end;

procedure TAQREditor.EditPropertyClick(Sender: TObject);
begin
  EditMode:=5;
end;

procedure TAQREditor.PopupChangeClick(Sender: TObject);
begin
  EditControl(PopupControl);
end;

procedure TAQREditor.PopupDeleteClick(Sender: TObject);
begin
{  if not (PopupControl is TAQRBand) then
  begin}
    PopupControl.Free;
    popupControl:=nil
{  end;}
end;

procedure TAQREditor.FilePrintClick(Sender: TObject);
var QuickReport:{$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF};
    i:integer;
begin
  if assigned(FOnPrintPreview) then
    FOnPrintPreview(Self);
  QuickReport:=nil;
  with Owner do
    for i:=0 to ComponentCount-1 do
      if Components[i] is {$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF} then
      begin
        QuickReport:=Components[i] as {$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF};
        break;
      end;
  if QuickReport<>nil then
    QuickReport.Preview;
end;

procedure TAQREditor.EditCreateLabelClick(Sender: TObject);
begin
  EditMode:=3;
  CreateClass:=1;
end;

procedure TAQREditor.EditCreateShapeClick(Sender: TObject);
begin
  EditMode:=3;
  CreateClass:=2;
end;
procedure TAQREditor.EditCreateCellClick(Sender: TObject);
begin
  EditMode:=3;
  CreateClass:=4;
end;
procedure TAQREditor.EditCreateImageClick(Sender: TObject);
begin
  EditMode:=3;
  CreateClass:=5;
end;

procedure TAQREditor.PopupToBackClick(Sender: TObject);
begin
   PopupControl.SendtoBack;
end;
procedure TAQREditor.PopupTieClick(Sender: TObject);
begin
  if PopupControl is TAQRCell then
    TAQRCell(PopupControl).Tie;
end;
procedure TAQREditor.PopupUntieClick(Sender: TObject);
begin
  if PopupControl is TAQRCell then
    TAQRCell(PopupControl).Untie;
end;

procedure TAQREditor.PopupToFrontClick(Sender: TObject);
begin
  PopupControl.BringtoFront;
end;

procedure TAQREditor.FilePrinterClick(Sender: TObject);
var PrinterSetupDialog1:TPrinterSetupDialog;
{$IFDEF QR20}
    QuickReport:TQuickRep;
    i:integer;
    settings:TPrinterSettings;
{$ENDIF}
begin
{$IFDEF QR20}
  QuickReport:=nil;
  with Owner do
  begin
    for i:=0 to ComponentCount-1 do
      if Components[i] is TQuickRep then
        QuickReport:=Components[i] as TQuickRep;
  end;
  settings:=TPrinterSettings.Create;
{$ENDIF}
  PrinterSetupDialog1:=TPrinterSetupDialog.Create(Owner);
  try
{$IFDEF QR20}
  settings.Printer:=Printer;
  settings.Orientation:=QuickReport.page.Orientation;
  settings.paperSize:=QuickReport.page.PaperSize;
  settings.applySettings;
{$ENDIF}
{$IFNDEF WIN32}
  PrinterSetupDialog1.Execute;
{$ELSE}
  if PrinterSetupDialog1.Execute then
  begin
{$IFDEF QR20}
    settings.Printer:=Printer;
    QuickReport.page.PaperSize:=settings.paperSize;
    QuickReport.page.Orientation:=printer.Orientation;
{$ENDIF}
  end;
{$ENDIF}
  finally
  PrinterSetupDialog1.Free;
{$IFDEF QR20}
  settings.Free;
{$ENDIF}
  end;
end;

procedure TAQREditor.FilePageClick(Sender: TObject);
var FirstQRBand:TQRBand;
    QuickReport:{$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF};
    i:integer;
begin
  FirstQRBand:=nil;
  QuickReport:=nil;
  with Owner do
  begin
    for i:=0 to ComponentCount-1 do
      if Components[i] is TQRBand then
      begin
        if (Components[i] as TQRBand).BandType=rbPageHeader then
          FirstQRBand:=(Components[i] as TQRBand);
      end
      else if Components[i] is {$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF} then
        QuickReport:=Components[i] as {$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF};
  end;
  if PageSetupFrm=nil then
      Application.CreateForm(TPageSetupFrm, PageSetupFrm);
  with PageSetupFrm do
  begin
    {$IFDEF QR20}
    PageLeft.text:=FloatToStrF(QuickReport.Page.LeftMargin,ffFixed,8,1);
     PageTop.text:=FloatToStrF(QuickReport.Page.TopMargin,ffFixed,8,1);
    PageRight.text:=FloatToStrF(QuickReport.Page.RightMargin,ffFixed,8,1);
     PageBottom.text:=FloatToStrF(QuickReport.Page.BottomMargin,ffFixed,8,1);
    {$ELSE}
    PageLeft.text:=intToStr(QuickReport.LeftMarginMM);
    if FirstQRBand=nil then
      PageTop.text:='0'
    else
      PageTop.text:=intToStr((FirstQRBand.Height*10+37) div 38);
    PageRight.text:='0';
    PageBottom.text:='0';
    {$ENDIF}
    ShowModal;
  end;
  if PageSetupFrm.ModalResult=mrOk then
  begin
    try
    {$IFDEF QR20}
      QuickReport.Page.LeftMargin:=strToFloat(PageSetupFrm.PageLeft.text);
      QuickReport.Page.TopMargin:=strToFloat(PageSetupFrm.PageTop.text);
      QuickReport.Page.RightMargin:=strToFloat(PageSetupFrm.PageRight.text);
      QuickReport.Page.BottomMargin:=strToFloat(PageSetupFrm.PageBottom.text);
    {$ELSE}
    QuickReport.LeftMarginMM:=strToint(PageSetupFrm.PageLeft.text);
    if FirstQRBand<>nil then
      FirstQRBand.Height:=(strToint(PageSetupFrm.PageTop.text)*38) div 10;
    {$ENDIF}
    except
      ;
    end;
  end;
end;

procedure TAQREditor.EditCreateMemoClick(Sender: TObject);
begin
  EditMode:=3;
  CreateClass:=3;
end;
procedure TAQREditor.EditCreateBandClick(Tip:TQRBandType);
var i:integer;
    QuickReport:{$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF};
begin
  QuickReport:=nil;
  with Owner do
    for i:=0 to ComponentCount-1 do
      if Components[i] is {$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF} then
      begin
        QuickReport:=Components[i] as {$IFDEF QR20}TQuickRep{$ELSE}TQuickReport{$ENDIF};
        break;
      end;
  i:=1;
  while Owner.FindComponent('QRBand'+inttostr(i))<>nil do
    i:=i+1;
  with TAQRBand.Create(Owner) do
  begin
    Name:='QRBand'+inttostr(i);
    Parent:={$IFDEF QR20}QuickReport{$ELSE}TForm(Self.Owner){$ENDIF};
    BandType:=Tip;
  {$IFDEF QR20}
    Size.Width:=10.0;
  {$ELSE}
    Ruler:=qrrCmHV;
  {$ENDIF}
    OnMouseDown:=ControlMouseDown;
    OnMouseUp:=ControlMouseUp;
    OnMouseMove:=ControlMouseMove;
  end;
end;
procedure TAQREditor.EditCreateBand1Click(Sender:TObject);
begin
  EditCreateBandClick(rbTitle);
end;
procedure TAQREditor.EditCreateBand2Click(Sender:TObject);
begin
  EditCreateBandClick(rbDetail);
end;
procedure TAQREditor.EditCreateBand3Click(Sender:TObject);
begin
  EditCreateBandClick(rbSummary);
end;
procedure TAQREditor.EditCreateBand4Click(Sender:TObject);
begin
  EditCreateBandClick(rbPageHeader);
end;
procedure TAQREditor.EditCreateBand5Click(Sender:TObject);
begin
  EditCreateBandClick(rbPageFooter);
end;
procedure TAQREditor.FileFieldsClick(Sender:TObject);
begin
  if FFieldDefs=nil then
    TAQREditorFields.Create(Owner);
  if FFieldDefs=nil then
    Exit;
  if FieldsSetupFrm=nil then
    Application.CreateForm(TFieldsSetupFrm, FieldsSetupFrm);
  with FieldsSetupFrm do
  begin
    Memo1.Lines.Assign(FFieldDefs.FFieldNames);
    Memo2.Lines.Assign(FFieldDefs.FFieldFormats);
    ShowModal;
    if ModalResult=mrOK then
    begin
      FFieldDefs.FFieldNames.Assign(Memo1.Lines);
      FFieldDefs.FFieldFormats.Assign(Memo2.Lines);
    end;
  end;
end;

procedure TAQREditor.EditReport;
var PopupItems:array [0..6] of TMenuItem;
    FileItems:array [0..7] of TMenuItem;
    EditItems:array [0..3] of TMenuItem;
    MainItems:array [0..1] of TMenuItem;
    MainItem:TMenuItem;
{$IFDEF QR20}
    CreateItems:array [0..5] of TMenuItem;
{$ELSE}
    CreateItems:array [0..3] of TMenuItem;
{$ENDIF}
    CreateBands:array [0..4] of TMenuItem;
begin
  if PopupMenu=nil then
  begin
    PopupItems[0]:=NewItem(LoadStr(SPosSize),0,False,True,PopupMoveClick,
       0,'PopupMove');
    PopupItems[1]:=NewItem(LoadStr(SProp),0,False,True,PopupChangeClick,
       0,'PopupChange');
    PopupItems[2]:=NewItem(LoadStr(SDelete),0,False,True,PopupDeleteClick,
       0,'PopupDelete');
    PopupItems[3]:=NewItem(LoadStr(SToBack),0,False,True,PopupToBackClick,
       0,'PopupToBack');
    PopupItems[4]:=NewItem(LoadStr(SToFront),0,False,True,PopupToFrontClick,
       0,'PopupToFront');
    PopupItems[5]:=NewItem(LoadStr(STie),0,False,False,PopupTieClick,
       0,'PopupTie');
    PopupItems[6]:=NewItem(LoadStr(SUntie),0,False,False,PopupUntieClick,
       0,'PopupUntie');
    PopupMenu:=NewPopupMenu(Self,'AQREditorPopupMenu',paLeft,True,PopupItems);
  end;
  if MainMenu=nil then
  begin
    FileItems[0]:=NewItem(LoadStr(SOpen),0,False,True,FileOpenClick,
       0,'FileOpen');
    FileItems[1]:=NewItem(LoadStr(SSave),0,False,True,FileSaveClick,
       0,'FileSave');
    FileItems[2]:=NewItem(LoadStr(SPrinter),0,False,True,FilePrinterClick,
       0,'FilePrinter');
    FileItems[3]:=NewItem(LoadStr(SPrint),0,False,True,FilePrintClick,
       0,'FilePrint');
    FileItems[4]:=NewItem(LoadStr(SPageProp),0,False,True,FilePageClick,
       0,'FilePage');
    FileItems[5]:=NewItem(LoadStr(SFieldsProp),0,False,True,FileFieldsClick,
       0,'FileFields');
    FileItems[6]:=NewLine;
    FileItems[7]:=NewItem(LoadStr(SClose),0,False,True,FileCloseClick,
       0,'FileClose');
    CreateBands[0]:=NewItem(LoadStr(STitle),0,False,True,EditCreateBand1Click,
       0,'EditCreateBand1');
    CreateBands[1]:=NewItem(LoadStr(SDetail),0,False,True,EditCreateBand2Click,
       0,'EditCreateBand2');
    CreateBands[2]:=NewItem(LoadStr(SSummary),0,False,True,EditCreateBand3Click,
       0,'EditCreateBand3');
    CreateBands[3]:=NewItem(LoadStr(SPageHeader),0,False,True,EditCreateBand4Click,
       0,'EditCreateBand4');
    CreateBands[4]:=NewItem(LoadStr(SPageFooter),0,False,True,EditCreateBand5Click,
       0,'EditCreateBand5');
    CreateItems[0]:=NewItem(LoadStr(SCreateLabel),0,False,True,EditCreateLabelClick,
       0,'EditCreateLabel');
    CreateItems[1]:=NewItem(LoadStr(SCreateShape),0,False,True,EditCreateShapeClick,
       0,'EditCreateShape');
    CreateItems[2]:=NewItem(LoadStr(SCreateMemo),0,False,True,EditCreateMemoClick,
       0,'EditCreateMemo');
{$IFDEF QR20}
    CreateItems[3]:=NewItem(LoadStr(SCreateImage),0,False,True,EditCreateImageClick,
       0,'EditCreateImage');
    CreateItems[4]:=NewItem(LoadStr(SCreateCell),0,False,True,EditCreateCellClick,
       0,'EditCreateCell');
    CreateItems[5]:=NewSubMenu(LoadStr(SBlock),0,'EditCreateBand',CreateBands);
{$ELSE}
    CreateItems[3]:=NewSubMenu(LoadStr(SBlock),0,'EditCreateBand',CreateBands);
{$ENDIF}
    EditItems[0]:=NewItem(LoadStr(SPosSize),0,False,True,EditMoveClick,
       0,'EditMove');
    EditItems[1]:=NewItem(LoadStr(SProp),0,False,True,EditPropertyClick,
       0,'EditProperty');
    EditItems[2]:=NewSubMenu(LoadStr(SCreate),0,'EditCreate',CreateItems);
    EditItems[3]:=NewItem(LoadStr(SDelete),0,False,True,EditDeleteClick,
       0,'EditDelete');
    MainMenu:=TMainMenu.Create(Self);
    MainMenu.Items.Add(NewSubMenu(LoadStr(SFile),0,'FileMenu',FileItems));
    MainMenu.Items.Add(NewSubMenu(LoadStr(SEdit),0,'EditMenu',EditItems));
    MainMenu.Items[0].GroupIndex:=15;
    MainMenu.Items[1].GroupIndex:=15;
  end;
  with Owner as TForm do
  begin
    menu:=mainmenu;
    enableEdit;
    if Assigned(FOnCreateMenu) then
      FOnCreateMenu(Self);
    Show;
  end
end;

procedure TAQREditor.DefaultFormatValue(const FormatStr:string;
      ValueType:TFormatValueType; ValuePtr:Pointer; var ResultStr:string);
type PString=^String;
     PInteger=^Longint;
     PFloat=^Extended;
     PDateTime=^TDateTime;
begin
  case ValueType of
  fvInteger: ResultStr:=FormatFloat(FormatStr,(PInteger(ValuePtr)^));
  fvFloat: ResultStr:=FormatFloat(FormatStr,(PFloat(ValuePtr)^));
  fvDateTime: ResultStr:=FormatDateTime(FormatStr,(PDateTime(ValuePtr)^));
  fvString: ResultStr:=(PString(ValuePtr)^);
  end;
end;

procedure TAQREditor.DoFormatValue(const FormatStr:string;
      ValueType:TFormatValueType; ValuePtr:Pointer; var ResultStr:string);
begin
  if Assigned(FOnFormatValue) then
    FOnFormatValue(Self,FormatStr,ValueType,ValuePtr,ResultStr)
  else
    DefaultFormatValue(FormatStr,ValueType,ValuePtr,ResultStr);
end;

procedure TAQREditor.SetFieldInteger(const FieldName:string; Value:longint);
begin
  SetFieldValue(FieldName,fvInteger,Pointer(@Value));
end;

procedure TAQREditor.SetFieldFloat(const FieldName:string; Value:extended);
begin
  SetFieldValue(FieldName,fvFloat,Pointer(@Value));
end;

procedure TAQREditor.SetFieldString(const FieldName:string; const Value:string);
begin
  SetFieldValue(FieldName,fvString,Pointer(@Value));
end;

procedure TAQREditor.SetFieldDateTime(const FieldName:string; Value:TDateTime);
begin
  SetFieldValue(FieldName,fvDateTime,Pointer(@Value));
end;

procedure TAQREditor.SetFieldValue(const FieldName:string; ValueType:TFormatValueType; ValuePtr:Pointer);
var i:integer;
    Res:string;
begin
  with owner do
    for i:=0 to ComponentCount-1 do
    begin
      if (Components[i] is TAQRLabel) then
      begin
        if CompareText((Components[i] as TAQRLabel).FieldName,FieldName)=0 then
        begin
          DoFormatValue((Components[i] as TAQRLabel).FieldFormat,ValueType,ValuePtr,Res);
          (Components[i] as TAQRLabel).Caption:=Res;
        end;
      end
      else if (Components[i] is TAQRMemo) then
      begin
        if CompareText((Components[i] as TAQRMemo).FieldName,FieldName)=0 then
        begin
          DoFormatValue((Components[i] as TAQRMemo).FieldFormat,ValueType,ValuePtr,Res);
          with (Components[i] as TAQRMemo).Lines do
          begin
            Clear;
            Add(Res);
          end;
        end;
      end;
    end;
end;

initialization
  Classes.RegisterClass(TAQRLabel);
  Classes.RegisterClass(TAQRMemo);
  Classes.RegisterClass(TAQRShape);
{$IFDEF QR20}
  Classes.RegisterClass(TAQRCell);
  Classes.RegisterClass(TAQRImage);
  Classes.RegisterClass(TQuickRep);
{$ELSE}
  Classes.RegisterClass(TQuickReport);
{$ENDIF}
  Classes.RegisterClass(TAQRBand);
  Classes.RegisterClass(TAQREditorFields);
  Classes.RegisterClass(TAQREditor);
  ReportSaving:=False;
{$IFDEF WIN32}
finalization
  Classes.UnRegisterClass(TAQRLabel);
  Classes.UnRegisterClass(TAQRMemo);
  Classes.UnRegisterClass(TAQRShape);
{$IFDEF QR20}
  Classes.UnRegisterClass(TAQRImage);
  Classes.UnRegisterClass(TAQRCell);
{$ENDIF}
  Classes.UnRegisterClass(TAQRBand);
  Classes.UnRegisterClass(TAQREditorFields);
  Classes.UnRegisterClass(TQuickRep);
  Classes.UnRegisterClass(TAQREditor);
{$ENDIF}
end.
